new;
library option,pgraph;
optionSet;

cls;

K = seqa(80,10,5);
nK = rows(K);

sigma = 0.20;
tau = 1/12;
r = 0.05;
S0 = 100;
V0 = 0.2^2; 
theta = V0; 
Kappa = 0.5; 
sigmaV = 0.25; 
lambda = 0;  

rho = 0.5;

_int_order = 128;
_int_mtd = 2;
dK = 0.10;
ImpVol = EuropeanHeston_ImpVol(S0,K,tau,r,V0,kappa,theta,sigmaV,rho,lambda);
Skew = EuropeanHeston_Skew(S0,K,tau,r,V0,kappa,theta,sigmaV,rho,lambda,dK);

proc (1) = BCC_K(K);
  local C,P;
  {C,P} = EuropeanHeston(S0,K,tau,r,V0,kappa,theta,sigmaV,rho,lambda);
  retp(-C);
endp;

BC0 = BinaryBS(S0,K,ImpVol,tau,r,r);
BC1 = BinarySmiled(S0,K,ImpVol,tau,r,r,Skew);
BC2 = BinaryHeston(S0,K,tau,r,V0,kappa,theta,sigmaV,rho,lambda);
BC3 = _option_gradp(&BCC_K,K,0);
print $ftocv(100*(BC0~BC1~BC2~BC3),2,3);
