new;
library option,gWizard,pgraph;

cls;

S0 = seqa(3,0.05,16);
K = 3.250;
sigma = 0.20;
tau = 90/365;
r = 0.08;
rstar = 0.05;
b = r - rstar;
N = 7;

{Cam,tree} = AmericanCRR(S0,K,sigma,tau,b,r,N);

treeC = vread(tree,"CallPut");
treeS = vread(tree,"S");

tree = vread(tree,"CallPut");
call PrintTree(tree,2);

pqgwin many;

graphset;

  gBuffer = PlotTree(tree,2);

  call gWizardInfo(gBuffer);
  _paxht = 0.30; _pnumht = 0.30; _ptitlht = 0.30;


  begwind;
  window(4,4,0);
   i = 1;
   do until i > 16;
     setwind(i);
     gWizardSet(gBuffer,i);

     _psym[.,4] = 10*ones(rows(_psym),1);
     _psym[.,5] = ceil(rndu(rows(_psym),1)*15);
     _pline[.,8] = ceil(rndu(rows(_pline),1)*15);

     gWizardDraw(gBuffer,i);
     i = i + 1;
  endo;

  endwind;

graphset;

  gWizardSet(gBuffer,1);
  gWizardDraw(gBuffer,1);
