new;
library option,pgraph;
optionSet;

cls;

S0 = 100;
K = 100;
tau = 0.25;
r = 0.05;
Sigma0 = 0.20^2;
kappa = 1;
theta = Sigma0;
sigmaV = 0.20;
rho = 0.5;
lambda = 0;

// You may use a Laguerre quadrature

_int_order = 128;
_int_mtd = 2;
print " --- Laguerre Quadrature Methods (order = 128) --- ";

_Heston_Model = 1;
{C,P} = EuropeanHeston(S0,K,tau,r,Sigma0,kappa,theta,sigmaV,rho,lambda);
str = ftos(C,"C = %lf",5,3) $+ " --- " $+ ftos(P,"P = %lf",5,3);
print /flush str;

_Heston_Model = 2;
{C,P} = EuropeanHeston(S0,K,tau,r,Sigma0,kappa,theta,sigmaV,rho,lambda);
str = ftos(C,"C = %lf",5,3) $+ " --- " $+ ftos(P,"P = %lf",5,3);
print /flush str;

_Heston_Model = 3;
{C,P} = EuropeanHeston(S0,K,tau,r,Sigma0,kappa,theta,sigmaV,rho,lambda);
str = ftos(C,"C = %lf",5,3) $+ " --- " $+ ftos(P,"P = %lf",5,3);
print /flush str;
print;

// You may use a Legendre quadrature

_int_order = 256;
_int_mtd = 1;
print " --- Legendre Quadrature Methods (order = 256) --- ";

_Heston_Model = 1;
{C,P} = EuropeanHeston(S0,K,tau,r,Sigma0,kappa,theta,sigmaV,rho,lambda);
str = ftos(C,"C = %lf",5,3) $+ " --- " $+ ftos(P,"P = %lf",5,3);
print /flush str;

_Heston_Model = 2;
{C,P} = EuropeanHeston(S0,K,tau,r,Sigma0,kappa,theta,sigmaV,rho,lambda);
str = ftos(C,"C = %lf",5,3) $+ " --- " $+ ftos(P,"P = %lf",5,3);
print /flush str;

_Heston_Model = 3;
{C,P} = EuropeanHeston(S0,K,tau,r,Sigma0,kappa,theta,sigmaV,rho,lambda);
str = ftos(C,"C = %lf",5,3) $+ " --- " $+ ftos(P,"P = %lf",5,3);
print /flush str;
print;

// You may use a Simpson algorithm
_int_order = 100000;
_int_mtd = 5;
print " --- Simpson algorithm (order = 256) --- ";

_Heston_Bounds = 500|0;  // With Simpson algorithm, you must paid attention to the bounds

_Heston_Model = 1;
{C,P} = EuropeanHeston(S0,K,tau,r,Sigma0,kappa,theta,sigmaV,rho,lambda);
str = ftos(C,"C = %lf",5,3) $+ " --- " $+ ftos(P,"P = %lf",5,3);
print /flush str;

_Heston_Model = 2;
{C,P} = EuropeanHeston(S0,K,tau,r,Sigma0,kappa,theta,sigmaV,rho,lambda);
str = ftos(C,"C = %lf",5,3) $+ " --- " $+ ftos(P,"P = %lf",5,3);
print /flush str;

_Heston_Model = 3;
{C,P} = EuropeanHeston(S0,K,tau,r,Sigma0,kappa,theta,sigmaV,rho,lambda);
str = ftos(C,"C = %lf",5,3) $+ " --- " $+ ftos(P,"P = %lf",5,3);
print /flush str;
