new;
library option,pgraph;
optionSet;

cls;

x0 = 10;
mu = 0.1;
sigma = 0.5;

t = qmc_Generate_t(0,3,501);  // t = seqa(0,3/500,501);
Nt = rows(t);

rndset("gauss",0,0);

x = qmc_simulate_GBM(x0,mu,sigma,t,2);

pqgwin many;

graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|3; _plwidth = 10; _pframe = 0;
  title("\216Two simulations of the GBM process");
  xlabel("\216t"); ylabel("\216x(t)");
  xy(t,x);

x = simulate_GBM(x0,mu,sigma,t,10000);
m = meanc(x[Nt,.]');
print /flush ftos(m,"Mean of X(T) = %lf",1,2);

rndset("Faure",7,0);  // We use Faure sequences
t = qmc_Generate_t(0,3,_rnd_dim);
Nt = rows(t);
x = simulate_GBM(x0,mu,sigma,t,2);

graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|3; _plwidth = 10; _pframe = 0;
  title("\216Two simulations of the GBM process");
  xlabel("\216t"); ylabel("\216x(t)");
  xy(t,x);

x = simulate_GBM(x0,mu,sigma,t,10000);
m = meanc(x[Nt,.]');
print /flush ftos(m,"Mean of X(T) = %lf",1,2);

rndset("Faure",6,0);
t = qmc_Generate_t(0,3,_rnd_dim);
Nt = rows(t);
x = simulate_GBM(x0,mu,sigma,t,2);

graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|3; _plwidth = 10; _pframe = 0;
  title("\216Two simulations of the GBM process");
  xlabel("\216t"); ylabel("\216x(t)");
  xy(t,x);

x = simulate_GBM(x0,mu,sigma,t,10000);
m = meanc(x[Nt,.]');
print /flush ftos(m,"Mean of X(T) = %lf",1,2);

i = 30;
do until i > 100;
  rndset("GrayFaure",i,0);
  t = qmc_Generate_t(0,3,_rnd_dim);
  Nt = rows(t);
  x = simulate_GBM(x0,mu,sigma,t,10000);
  m = meanc(x[Nt,.]');
  print /flush ftos(i,"Faure dimension = %lf",3,0)$+ftos(m,"  /  Mean of X(T) = %lf",1,2);
  i = i + 1;
endo;