new;
library option,pgraph;
optionSet;

proc procMu(t,x);
  retp(0.8*(0.10-x));
endp;

proc procSigma(t,x);
  retp(exp(-(t-5)^2/3).*x);
endp;

t = qmc_Generate_t(0,10,501);  // You have to use a small time spacing, because we use the Euler Scheme and not an exact scheme
x = qmc_simulate_SDE(0.10,&procMu,&procSigma,t,2);

pqgwin many;

graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|3; _plwidth = 10; _pframe = 0;
  title("\216Two simulations of a time non-homogeneous stochastic process");
  xlabel("\216t"); ylabel("\216x(t)");
  xy(t,x);

call rndset("faure",rows(t),0);
x = qmc_simulate_SDE(0.10,&procMu,&procSigma,t,250);

graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|3; _plwidth = 10; _pframe = 0;
  title("\216250 simulations of a time non-homogeneous stochastic process\L\216QMC Faure sequences");
  xlabel("\216t"); ylabel("\216x(t)");
  xy(t,x);

