new;
library option,pgraph;

S0 = 100;
K = 100;
sigma = 0.20;
r = 0.05;
b = r;
tau = 1.0;
fn call_payoff(S,K) = (S - K) .* (S .>= K);
BS = EuropeanBS(S0,K,sigma,tau,b,r);

nS = 100000;
S = simulate_GBM(S0,r,sigma,tau,nS);

ST = S';

Cs = exp(-r*tau)*cumsumc(call_payoff(St,K))./seqa(1,1,Ns);

step = 10;
indx = seqa(1,step,nS/step);
Cs = Cs[indx];

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 9;
  ytics(8,12,0.5,2);
  _pline = 1~3~0~BS~nS~BS~1~12~10;
  xlabel("\216Number of simulations");
  graphprt("-c=1 -cf=mc1.eps");
  xy(indx,Cs);