new;
library option,pgraph;
OptionSet;

Strike = seqa(70,1,61);

let S0 = 100;
let sv = 0.50 0.1 0.1;

let K   =  90   100  120;
let Vol =  0.26 0.25 0.25;
{a,b,c,d,m} = PDM_Calibrate(S0,K,Vol,0,0,sv);
Smile = PDM_ImpVol(S0,Strike,a,b,c,d,m);

K1 = K; Vol1 = Vol; Smile1 = Smile;

let K   =  90   100  120;
let Vol =  0.30 0.25 0.21;
{a,b,c,d,m} = PDM_Calibrate(S0,K,Vol,0,0,sv);
Smile = PDM_ImpVol(S0,Strike,a,b,c,d,m);

K2 = K; Vol2 = Vol; Smile2 = Smile;

let K   =  90   100  130;
let Vol =  0.26 0.26 0.35;
{a,b,c,d,m} = PDM_Calibrate(S0,K,Vol,0,0,sv);
Smile = PDM_ImpVol(S0,Strike,a,b,c,d,m);

K3 = K; Vol3 = Vol; Smile3 = Smile;

let K   =  98   100  102;
let Vol =  0.252 0.25 0.251;
{a,b,c,d,m} = PDM_Calibrate(S0,K,Vol,0,0,sv);
Smile = PDM_ImpVol(S0,Strike,a,b,c,d,m);

K4 = K; Vol4 = Vol; Smile4 = Smile;

graphset;
  begwind;
  window(2,2,0);

    fonts("simplex simgrma");
    _pdate = ""; _pnum = 2; _pframe = 0;
    _paxht = 0.25; _pnumht = 0.22; _ptiltht = 0.25;
    _pltype = 6|1|3;
    _plwidth = 10;
    xlabel("\214Strike K");
    xtics(60,140,20,2);
    ytics(0.20,0.40,0.05,2);

  i = 1;
  setwind(i);
    _pcolor = 9 + i;
    _psym = K1~Vol1~ones(3,1).*(11~10~9+i~1~0);
    xy(Strike,Smile1);

  i = 2;
  setwind(i);
    _pcolor = 9 + i;
    _psym = K2~Vol2~ones(3,1).*(11~10~9+i~1~0);
    xy(Strike,Smile2);

  i = 3;
  setwind(i);
    _pcolor = 9 + i;
    _psym = K3~Vol3~ones(3,1).*(11~10~9+i~1~0);
    xy(Strike,Smile3);

  i = 4;
  setwind(i);
    _pcolor = 9 + i;
    _psym = K4~Vol4~ones(3,1).*(11~10~9+i~1~0);
    xy(Strike,Smile4);

  endwind;