new;
library option,pgraph;
optionSet;

seed = 134;

proc procMu(t,x);
  retp(1.5*x);
endp;

proc procSigma(t,x);
  retp(10*x);
endp;

proc procGradSigma(t,x);
  retp(10);
endp;

t = qmc_Generate_t(0,0.1,131);  // You have to use a small time spacing, because we use the Euler Scheme and not an exact scheme

rndseed seed;
x1 = qmc_simulate_SDE(0.10,&procMu,&procSigma,t,1);

rndseed seed;
x2 = qmc_simulate_SDE_milstein(0.10,&procMu,&procSigma,0,t,1);

rndseed seed;
x3 = qmc_simulate_SDE_milstein(0.10,&procMu,&procSigma,&procGradSigma,t,1);

graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|3; _plwidth = 10; _pframe = 0;
  title("\216Simulations of a GBM process");
  xlabel("\216t"); ylabel("\216x(t)");
  xy(t,x1~x2~x3);

